/* man init
 *
 * Run-level    Signal     Action  
 * 0            SIGUSR2    Halt and turn the power off       
 * 1            SIGTERM    Go to single-user mode            
 * 6            SIGINT     Reboot the machine                 
 * c            SIGTSTP    Block further logins                      
 * q            SIGHUP     Rescan the ttys(5) file                           
 *
 */

#include "avr.h"


int 
sendSIG(char * tmpRL) {

    // runlevel
    char *rl = tmpRL;

    // Return Signal to init
    int r = -1;
    
    if (DEBUG)
        printf("DEBUG: %s steht in &rl[0], atoi: %i\n", &rl[0], atoi(&rl[0]));
    
    
    switch(atoi(&rl[0])) {
         case 0:
         if(DEBUG)
	     printf("%i, %s\n", atoi(&rl[0]), &rl[0] );

             r = SIGUSR2;
             break;
         
         case 1:
             r = SIGTERM;
             break;
         
         case 6:
             r = SIGINT;
             break;

         default:
	     (void) voiceError(4);	
             break; 	
    }

    return r;
    
}




int
init(int mode) {

    int r;

    switch (mode){
    	case SIGUSR2:
    	    voiceError(1);			
    	    if ( kill(1, SIGUSR2) != 0)
    	    	fprintf(stderr,
   	    		" %s: Es trat ein Fehler beim Herunterfahren auf.\n",
   	    		strerror( errno));
	    r = 1;
	    break;


	case SIGTERM:
	    voiceError(2);
	    if( kill(1, SIGTERM) != 0 )
                fprintf(stderr,
                " %s: Es trat ein Fehler beim initialisieren des Rechners in den singleuser mode  auf.\n",
                 strerror(errno));
            r = 1;
            break;
            
                    
        case SIGINT:
            voiceError(3);
       	    if( kill(1, SIGINT) != 0)
       	        fprintf(stderr,
       	                " %s: Es trat ein Fehler beim Neustarten auf.\n",
	       	        strerror(errno));
	    r = 1;
       	    break;
       	
       	case SIGTSTP:
       	    if( kill(1, SIGTSTP) != 0)
       	    	fprintf(stderr,
       	    		" %s: Es trat ein Fehler beim Blocken von login Moeglichkeiten auf.\n",
       	    		strerror(errno));
       	    r = 1;
       	    break;
       	    		                
       	case SIGHUP:
       	    if( kill(1, SIGHUP) != 0)
       	        fprintf(stderr,
       	                " %s: Es trat ein Fehler beim neu initialisieren der ttys(5) Datei auf.\n",
       	                 strerror(errno));
       	    r = 1;
       	    break;
       	                                                                                      	                                                                                                               	    
        default:
            r = 0;
            (void)voiceError(4);
            break;
    }    

  return r;
}


void 
voiceError(int tmpI){

    int i;
    
    if (i != 0 && 
        i  > 0){
    	i = tmpI;
    } else { i = 3; }
    int b;
    for (b = 0;b < i; b++){
    
        printf("\007");
        fflush(stdout);
        sleep(1);
    }

}
